UNIT RIBSTAT;
{closely based ie modified status ribbon program}
{done by Tom Swan for MDI ribbbons              }

interface
uses objects, wintypes,winprocs,owindows,strings;

type
  pbotlneBar = ^TbotlneBar;
  TbotlneBar = object(Twindow)
    s : array [0..128] of char;
    childHeight : integer;
    constructor Init(AParent: PWindowsObject);
    function GetClassName: PChar; virtual;
    procedure SetupWindow; virtual;
    procedure GetWindowClass(var AWndClass:TWndClass); virtual;
    procedure Adjustsize(var parentWidth, ParentHeight : word);
    procedure SetDisplayLine(Info:PChar);
    procedure DisplayString(Clear :integer);
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
  end;
implementation

constructor TbotlneBar.init(Aparent : pwindowsobject);
begin
  TWindow.init(Aparent,'');
  Attr.Style := WS_Child + WS_Visible + WS_border;
  Attr.x := 0;Attr.y := 0;Attr.w := 0;attr.h := 0;
  if (Aparent = nil) then
    Status := EM_INVALIDCHILD;
end;

procedure TbotlneBar.SetupWindow;
var
  sbdc : HDC;
begin
  Twindow.setupwindow;
  childheight := GetSystemMetrics(SM_CYCAPTION);
  s[0] := #0;
end;
function TbotlneBar.GetClassName: PChar;
begin
  GetClassName := 'TbotlneBar';
end;

procedure TbotlneBar.GetWindowClass(var AWndClass : TWndClass);
begin
  Twindow.GetWindowClass(AWndClass);
  AwndClass.hbrBackground := GetStockObject(LTGRAY_BRUSH);
end;


Procedure TbotlneBar.Adjustsize(var parentWidth, ParentHeight : word);
var
  y : integer;
begin
  parentHeight := parentHeight - childHeight ;
  y := parentHeight ;
  MoveWindow(HWindow,0,y,parentWidth,ChildHeight,TRUE);
end;

procedure TbotlneBar.SetDisplayLine(Info:PChar);
begin
 strcopy(s,info);
 DisplayString(1);
end;

procedure TbotlneBar.DisplayString(clear :integer);
var
  r : TRECT;
  hdci : hdc;
begin
  if clear=0 then  s[0] := #0;
  GetClientRect(hwindow, R);
  hdci := GETDC(HWindow);
  OffsetRect(r,1,1);
  FillRect(hdci,r,GetStockObject(LTGRAY_BRUSH));
  FrameRect(hdci,r,GetStockObject(DKGRAY_BRUSH));
  OffsetRect(r,-1,-1);
  FrameRect(hdci,r,GetStockObject(WHITE_BRUSH));
  setbkmode(hdci,TRANSPARENT);
  EXTTextOut(hDCi,4,1,ETO_CLIPPED,@r,s,lstrlen(s),nil);
    releasedc(hwindow,hdci);  
end;

procedure TbotlneBar.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
begin
  DisplayString(1);
end;

end.
